%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Quantification over gam
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%[(3 hmtyinfer) module {%{EH}Gam.Quantify}
%%]

%%[(3 hmtyinfer) hs import ({%{EH}Base.Common}, {%{EH}Opts.Base})
%%]
%%[(3 hmtyinfer) hs import ({%{EH}Ty})
%%]
%%[(3 hmtyinfer) hs import ({%{EH}VarMp})
%%]

%%[(3 hmtyinfer) import(qualified Data.Set as Set)
%%]

%%[(3 hmtyinfer) import({%{EH}Ty.Trf.Quantify})
%%]
%%[(3 hmtyinfer) import({%{EH}VarMp},{%{EH}Substitutable})
%%]

%%[(9 hmtyinfer) import({%{EH}Ty.Trf.MergePreds})
%%]

%%[(3 hmtyinfer) hs import ({%{EH}Gam},{%{EH}Gam.ValGam})
%%]
%%[(6 hmtyinfer) hs import ({%{EH}Gam.TyKiGam})
%%]
%%[(17 hmtyinfer) hs import ({%{EH}Gam.PolGam})
%%]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For ValGam
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%[(3 hmtyinfer).valGamQuantify export(valGamQuantify)
valGamQuantify :: TyVarIdS -> ValGam -> ValGam
valGamQuantify globTvS = valGamMapTy (\t -> valTyQuantify (`Set.member` globTvS) t)
%%]

%%[(6 hmtyinfer).valGamQuantify -3.valGamQuantify export(valGamQuantify)
valGamQuantify :: TyKiGam -> VarMp -> VarMp -> TyVarIdS -> ValGam -> ValGam
valGamQuantify tyKiGam tvKiVarMp gamVarMp globTvS
  = valGamMapTy (\t -> valTyQuantify (tvarKi tyKiGam emptyGam tvKiVarMp gamVarMp) (`Set.member` globTvS) t)
%%]

%%[(8 hmtyinfer).valGamQuantifyWithVarMp -6.valGamQuantify export(valGamQuantifyWithVarMp)
valGamQuantifyWithVarMp :: TyKiGam -> VarMp -> VarMp -> TyVarIdS -> ValGam -> (ValGam,VarMp,VarMp)
valGamQuantifyWithVarMp tyKiGam tvKiVarMp gamVarMp globTvS gam
  = valGamDoWithVarMp
      (\_ (t,tyCycMp) m cycMp -> (valTyQuantify (tvarKi tyKiGam emptyGam tvKiVarMp gamVarMp) (`Set.member` globTvS) t,m,tyCycMp `varUpd` cycMp))
      gamVarMp emptyVarMp gam
%%]

%%[(9 hmtyinfer).valGamQuantify -3.valGamQuantify export(valGamQuantify)
valGamQuantify :: TyVarIdS -> [PredOcc] -> ValGam -> (ValGam,TQOGam)
valGamQuantify globTvS prL g
  =  let  g' = gamMapElts  (\vgi ->  let  tmpo = tyMergePreds prL (vgiTy vgi)
                                          ty   = valTyQuantify (const kiStar) (`Set.member` globTvS) (tmpoTy tmpo)
                                     in   (vgi {vgiTy = ty},tmpo {tmpoTy = ty})
                           ) g
     in   gamUnzip g'
%%]

%%[(9 hmtyinfer).valGamQuantifyWithVarMp -8.valGamQuantifyWithVarMp export(valGamQuantifyWithVarMp)
valGamQuantifyWithVarMp :: Bool -> TyKiGam -> VarMp -> VarMp -> TyVarIdS -> [PredOcc] -> ValGam -> (ValGam,VarMp,(VarMp,TQOGam))
valGamQuantifyWithVarMp doQuant tyKiGam tvKiVarMp gamVarMp globTvS prL valGam
  = valGamDoWithVarMp quant gamVarMp (emptyVarMp,emptyGam) valGam
  where quant nm (t,tyCycVarMp) newVarMp (cycVarMp,tmpoGam)
          = ( ty
            , newVarMp
            , (tyCycVarMp `varUpd` cycVarMp
              , gamAdd nm (tmpo {tmpoTy = ty}) tmpoGam
            ) )
          where tmpo           = tyMergePreds prL t
                ty | doQuant   = valTyQuantify (tvarKi tyKiGam emptyGam tvKiVarMp gamVarMp) (`Set.member` globTvS) (tmpoTy tmpo)
                   | otherwise = tmpoTy tmpo
%%]
                newVarMp'   = newVarMp -- tmpoImplsVarMp tmpo `varmpPlus` m
                tmpoGam'    = gamAdd nm (tmpo {tmpoTy = ty}) tmpoGam
                cycVarMp'   = tyCycVarMp `varUpd` cycVarMp

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For TyKiGam
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%[(6 hmtyinfer).tyKiGamQuantify export(tyKiGamQuantify)
tyKiGamQuantify :: EHCOpts -> TyVarIdS -> TyKiGam -> TyKiGam
tyKiGamQuantify opts globTvS
  = gamMap (\(n,k) -> (n,k {tkgiKi = tyKiQuantify (ehcOptPolyKinds opts) (`Set.member` globTvS) (tkgiKi k)}))
%%]

%%[(8 hmtyinfer).tyKiGamQuantifyWithVarMp -6.tyKiGamQuantify export(tyKiGamQuantifyWithVarMp)
tyKiGamQuantifyWithVarMp :: EHCOpts -> VarMp -> TyVarIdS -> TyKiGam -> (TyKiGam,VarMp,VarMp)
tyKiGamQuantifyWithVarMp opts {- tyKiGam tvKiVarMp -} gamVarMp globTvS gam
  = tyKiGamDoWithVarMp
      (\_ (t,tyCycMp) m cycMp -> (tyKiQuantify (ehcOptPolyKinds opts) {- (tvarKi tyKiGam tvKiVarMp gamVarMp) -} (`Set.member` globTvS) t,m,tyCycMp `varUpd` cycMp))
      gamVarMp emptyVarMp gam
%%]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For PolGam
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%[(17 hmtyinfer) export( quantifyPolGam)
quantifyPolGam :: PolGam -> PolGam
quantifyPolGam gam
  = let fvs = varFree gam
        notElemFtvs tv = not $ elem tv fvs
     in mapPolGam (tyQuantify notElemFtvs) gam
%%]

